diff --git a/src/main/java/net/minecraft/client/entity/particle/RedstoneDustParticle.java b/src/main/java/net/minecraft/client/entity/particle/RedstoneDustParticle.java
index 7126d32d3..e5504509f 100644
--- a/src/main/java/net/minecraft/client/entity/particle/RedstoneDustParticle.java
+++ b/src/main/java/net/minecraft/client/entity/particle/RedstoneDustParticle.java
@@ -8,7 +8,7 @@ import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 
 public class RedstoneDustParticle extends Particle {
-    float oSize;
+    private final float oSize;
     private int brightness;
 
     public RedstoneDustParticle(World world, double x, double y, double z, float red, float green, float blue, int brightness) {
@@ -18,31 +18,31 @@ public class RedstoneDustParticle extends Particle {
     public RedstoneDustParticle(World world, double x, double y, double z, float scale, float red, float green, float blue, int brightness) {
         super(world, x, y, z, 0.0D, 0.0D, 0.0D);
         this.brightness = -1;
-        if (brightness >= 0){
+        if (brightness >= 0) {
             this.brightness = brightness;
         }
         this.xd *= 0.1D;
         this.yd *= 0.1D;
         this.zd *= 0.1D;
-        float n = (float)Math.random() * 0.4F + 0.6F;
-        this.rCol = ((float)(Math.random() * 0.2D) + 0.8F) * red * n;
-        this.gCol = ((float)(Math.random() * 0.2D) + 0.8F) * green * n;
-        this.bCol = ((float)(Math.random() * 0.2D) + 0.8F) * blue * n;
+        float n = (float) Math.random() * 0.4F + 0.6F;
+        this.rCol = ((float) (Math.random() * 0.2D) + 0.8F) * red * n;
+        this.gCol = ((float) (Math.random() * 0.2D) + 0.8F) * green * n;
+        this.bCol = ((float) (Math.random() * 0.2D) + 0.8F) * blue * n;
         this.size *= 0.75F;
         this.size *= scale;
         this.oSize = this.size;
-        this.lifetime = (int)(8D / (Math.random() * 0.8D + 0.2D));
+        this.lifetime = (int) (8D / (Math.random() * 0.8D + 0.2D));
         this.lifetime *= (int) scale;
         this.noPhysics = false;
     }
 
     @Override
-    public void render(Tessellator t, float partialTick, float xa, float ya, float za, float xa2, float za2) {
+    public void render(Tessellator t, float partialTick, double xOff, double yOff, double zOff, float xa, float ya, float za, float xa2, float za2) {
         float l = ((this.age + partialTick) / this.lifetime) * 32F;
         if (l < 0.0F) {
             l = 0.0F;
         }
-        if(l > 1.0F) {
+        if (l > 1.0F) {
             l = 1.0F;
         }
         this.size = this.oSize * l;
@@ -53,11 +53,11 @@ public class RedstoneDustParticle extends Particle {
         float v0 = (float) this.tex.getIconVMin();
         float v2 = (float) this.tex.getSubIconV(1);
         float r = 0.1F * this.size;
-        float x = (float)(this.xo + (this.x - this.xo) * partialTick - RedstoneDustParticle.xOff);
-        float y = (float)(this.yo + (this.y - this.yo) * partialTick - RedstoneDustParticle.yOff);
-        float z = (float)(this.zo + (this.z - this.zo) * partialTick - RedstoneDustParticle.zOff);
+        float x = (float) (this.xo + (this.x - this.xo) * partialTick - xOff);
+        float y = (float) (this.yo + (this.y - this.yo) * partialTick - yOff);
+        float z = (float) (this.zo + (this.z - this.zo) * partialTick - zOff);
         float br = 1f;
-        if(LightmapHelper.isLightmapEnabled()) {
+        if (LightmapHelper.isLightmapEnabled()) {
             int xTile = MathHelper.floor(this.x);
             int yTile = MathHelper.floor(this.y);
             int zTile = MathHelper.floor(this.z);
@@ -79,7 +79,7 @@ public class RedstoneDustParticle extends Particle {
     }
 
     @Override
-	public void tick() {
+    public void tick() {
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
@@ -87,13 +87,13 @@ public class RedstoneDustParticle extends Particle {
             this.remove();
         }
         int val = (7 - ((this.age * 8) / this.lifetime));
-        if (val >= 0){
+        if (val >= 0) {
             this.tex = TextureRegistry.getTexture("minecraft:particle/puff_" + val);
         } else {
             this.tex = null;
         }
         this.move(this.xd, this.yd, this.zd);
-        if(this.y == this.yo) {
+        if (this.y == this.yo) {
             this.xd *= 1.1D;
             this.zd *= 1.1D;
         }
diff --git a/src/main/java/net/minecraft/client/entity/particle/SlimeChunkParticle.java b/src/main/java/net/minecraft/client/entity/particle/SlimeChunkParticle.java
index ecf458f3f..02fd9054f 100644
--- a/src/main/java/net/minecraft/client/entity/particle/SlimeChunkParticle.java
+++ b/src/main/java/net/minecraft/client/entity/particle/SlimeChunkParticle.java
@@ -6,6 +6,7 @@ import net.minecraft.client.render.LightmapHelper;
 //            EntityFX, Item, Block, Tessellator,
 //            World
 
+import net.minecraft.client.render.ParticleEngine;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.item.Item;
@@ -22,25 +23,25 @@ public class SlimeChunkParticle extends Particle {
     }
 
     @Override
-	public int getParticleTexture() {
-        return 2;
+    public int getParticleTexture() {
+        return ParticleEngine.ITEM_TEXTURE;
     }
 
     @Override
-    public void render(Tessellator t, float partialTick, float xa, float ya, float za, float xa2, float za2) {
+    public void render(Tessellator t, float partialTick, double xOff, double yOff, double zOff, float xa, float ya, float za, float xa2, float za2) {
         float u0 = (float) this.tex.getSubIconU(this.uo / 4F);
         float u2 = (float) this.tex.getSubIconU(0.25f + this.uo / 4F);
         float v0 = (float) this.tex.getSubIconV(this.uo / 4F);
         float v2 = (float) this.tex.getSubIconV(0.25f + this.uo / 4F);
         float r = 0.1F * this.size;
-        float x = (float)(this.xo + (this.x - this.xo) * partialTick - SlimeChunkParticle.xOff);
-        float y = (float)(this.yo + (this.y - this.yo) * partialTick - SlimeChunkParticle.yOff);
-        float z = (float)(this.zo + (this.z - this.zo) * partialTick - SlimeChunkParticle.zOff);
+        float x = (float) (this.xo + (this.x - this.xo) * partialTick - xOff);
+        float y = (float) (this.yo + (this.y - this.yo) * partialTick - yOff);
+        float z = (float) (this.zo + (this.z - this.zo) * partialTick - zOff);
         float br = 1.0f;
         if (LightmapHelper.isLightmapEnabled()) {
-        	t.setLightmapCoord(getLightmapCoord(partialTick));
+            t.setLightmapCoord(getLightmapCoord(partialTick));
         } else {
-        	br = getBrightness(partialTick);
+            br = getBrightness(partialTick);
         }
         t.setColorOpaque_F(br * this.rCol, br * this.gCol, br * this.bCol);
         t.addVertexWithUV(x - xa * r - xa2 * r, y - ya * r, z - za * r - za2 * r, u0, v2);
diff --git a/src/main/java/net/minecraft/client/entity/particle/SmokeParticle.java b/src/main/java/net/minecraft/client/entity/particle/SmokeParticle.java
index a3eeaac7e..ae6b527b1 100644
--- a/src/main/java/net/minecraft/client/entity/particle/SmokeParticle.java
+++ b/src/main/java/net/minecraft/client/entity/particle/SmokeParticle.java
@@ -5,7 +5,7 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.world.World;
 
 public class SmokeParticle extends Particle {
-    float oSize;
+    private final float oSize;
 
     public SmokeParticle(World world, double x, double y, double z, double xa, double ya, double za) {
         this(world, x, y, z, xa, ya, za, 1.0F);
@@ -29,7 +29,7 @@ public class SmokeParticle extends Particle {
     }
 
     @Override
-    public void render(Tessellator t, float partialTick, float xa, float ya, float za, float xa2, float za2) {
+    public void render(Tessellator t, float partialTick, double xOff, double yOff, double zOff, float xa, float ya, float za, float xa2, float za2) {
         float l = ((this.age + partialTick) / this.lifetime) * 32F;
         if (l < 0.0F) {
             l = 0.0F;
@@ -38,7 +38,7 @@ public class SmokeParticle extends Particle {
             l = 1.0F;
         }
         this.size = this.oSize * l;
-        super.render(t, partialTick, xa, ya, za, xa2, za2);
+        super.render(t, partialTick, xOff, yOff, zOff, xa, ya, za, xa2, za2);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/entity/particle/SnowShovelParticle.java b/src/main/java/net/minecraft/client/entity/particle/SnowShovelParticle.java
index fd46b2775..dc888765b 100644
--- a/src/main/java/net/minecraft/client/entity/particle/SnowShovelParticle.java
+++ b/src/main/java/net/minecraft/client/entity/particle/SnowShovelParticle.java
@@ -6,7 +6,7 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.world.World;
 
 public class SnowShovelParticle extends Particle {
-    float oSize;
+    private final float oSize;
 
     public SnowShovelParticle(World world, double x, double y, double z, double xa, double ya, double za) {
         this(world, x, y, z, xa, ya, za, 1.0F);
@@ -30,7 +30,7 @@ public class SnowShovelParticle extends Particle {
     }
 
     @Override
-    public void render(Tessellator t, float partialTick, float xa, float ya, float za, float xa2, float za2) {
+    public void render(Tessellator t, float partialTick, double xOff, double yOff, double zOff, float xa, float ya, float za, float xa2, float za2) {
         float l = ((this.age + partialTick) / this.lifetime) * 32F;
         if(l < 0.0F) {
             l = 0.0F;
@@ -39,7 +39,7 @@ public class SnowShovelParticle extends Particle {
             l = 1.0F;
         }
         this.size = this.oSize * l;
-        super.render(t, partialTick, xa, ya, za, xa2, za2);
+        super.render(t, partialTick, xOff, yOff, zOff, xa, ya, za, xa2, za2);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/entity/particle/TakeAnimationParticle.java b/src/main/java/net/minecraft/client/entity/particle/TakeAnimationParticle.java
index dd9252e5f..83386fad2 100644
--- a/src/main/java/net/minecraft/client/entity/particle/TakeAnimationParticle.java
+++ b/src/main/java/net/minecraft/client/entity/particle/TakeAnimationParticle.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.entity.particle;
 
+import net.minecraft.client.render.ParticleEngine;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.client.render.EntityRenderDispatcher;
@@ -9,16 +10,15 @@ import net.minecraft.core.world.World;
 import org.lwjgl.opengl.GL11;
 
 public class TakeAnimationParticle extends Particle {
-    private Entity item;
-    private Entity target;
+    private final Entity item;
+    private final Entity target;
     private int life;
-    private int lifeTime;
-    private float yOffs;
+    private final int lifeTime;
+    private final float yOffs;
 
     public TakeAnimationParticle(World world, Entity item, Entity target, float scale) {
         super(world, item.x, item.y, item.z, item.xd, item.yd, item.zd);
         this.life = 0;
-        this.lifeTime = 0;
         this.item = item;
         this.target = target;
         this.lifeTime = 3;
@@ -26,36 +26,36 @@ public class TakeAnimationParticle extends Particle {
     }
 
     @Override
-    public void render(Tessellator t, float partialTick, float xa, float ya, float za, float xa2, float za2) {
+    public void render(Tessellator t, float partialTick, double xOff, double yOff, double zOff, float xa, float ya, float za, float xa2, float za2) {
         float time = (this.life + partialTick) / this.lifeTime;
         time *= time;
         double xo = item.x;
         double yo = item.y;
         double zo = item.z;
-        double xt = target.xo + (target.x - target.xo) * (double) partialTick;
-        double yt = target.yo + (target.y - target.yo) * (double) partialTick + (double) yOffs;
-        double zt = target.zo + (target.z - target.zo) * (double) partialTick;
+        double xt = target.xo + (target.x - target.xo) * partialTick;
+        double yt = target.yo + (target.y - target.yo) * partialTick + yOffs;
+        double zt = target.zo + (target.z - target.zo) * partialTick;
         double xx = xo + (xt - xo) * time;
         double yy = yo + (yt - yo) * time;
         double zz = zo + (zt - zo) * time;
         int xTile = MathHelper.floor(xx);
-        int yTile = MathHelper.floor(yy + (double)(this.heightOffset / 2.0F));
+        int yTile = MathHelper.floor(yy + (this.heightOffset / 2.0F));
         int zTile = MathHelper.floor(zz);
-        xx -= TakeAnimationParticle.xOff;
-        yy -= TakeAnimationParticle.yOff;
-        zz -= TakeAnimationParticle.zOff;
+        xx -= xOff;
+        yy -= yOff;
+        zz -= zOff;
         float br = 1.0f;
-        if(LightmapHelper.isLightmapEnabled()) {
-        	LightmapHelper.setLightmapCoord(this.item.world.getLightmapCoord(xTile, yTile, zTile, 0));
-        }else {
-        	br = this.world.getLightBrightness(xTile, yTile, zTile);
+        if (LightmapHelper.isLightmapEnabled()) {
+            LightmapHelper.setLightmapCoord(this.item.world.getLightmapCoord(xTile, yTile, zTile, 0));
+        } else {
+            br = this.world.getLightBrightness(xTile, yTile, zTile);
         }
         GL11.glColor4f(br, br, br, 1.0F);
-        EntityRenderDispatcher.instance.renderEntityWithPosYaw(t, this.item, (float)xx, (float)yy, (float)zz, this.item.yRot, partialTick);
+        EntityRenderDispatcher.instance.renderEntityWithPosYaw(t, this.item, (float) xx, (float) yy, (float) zz, this.item.yRot, partialTick);
     }
 
     @Override
-	public void tick() {
+    public void tick() {
         this.life++;
         if (this.life == this.lifeTime) {
             remove();
@@ -63,7 +63,7 @@ public class TakeAnimationParticle extends Particle {
     }
 
     @Override
-	public int getParticleTexture() {
-        return 3;
+    public int getParticleTexture() {
+        return ParticleEngine.ENTITY_PARTICLE_TEXTURE;
     }
 }
diff --git a/src/main/java/net/minecraft/client/entity/particle/TerrainParticle.java b/src/main/java/net/minecraft/client/entity/particle/TerrainParticle.java
index 721c3bbb0..40d1e002b 100644
--- a/src/main/java/net/minecraft/client/entity/particle/TerrainParticle.java
+++ b/src/main/java/net/minecraft/client/entity/particle/TerrainParticle.java
@@ -5,6 +5,7 @@ import net.minecraft.client.render.LightmapHelper;
 // Referenced classes of package net.minecraft.src:
 //            EntityFX, Block, Tessellator, World
 
+import net.minecraft.client.render.ParticleEngine;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
@@ -17,16 +18,14 @@ public class TerrainParticle extends Particle {
     private final Block block;
     private final Side side;
 
-    public TerrainParticle(World world, double x, double y, double z, double xa, double ya, double za, Block block, int side, int meta)
-    {
+    public TerrainParticle(World world, double x, double y, double z, double xa, double ya, double za, Block block, Side side, int meta) {
         super(world, x, y, z, xa, ya, za);
-        this.side = Side.getSideById(side);
+        this.side = side;
         this.block = block;
         this.tex = BlockModelDispatcher.getInstance().getDispatch(block).getParticleTexture(this.side, meta);
         this.gravity = block != null ? block.blockParticleGravity : 0;
         this.rCol = this.gCol = this.bCol = 0.6F;
         this.size /= 2.0F;
-
     }
 
     public TerrainParticle init(int x, int y, int z) {
@@ -42,26 +41,26 @@ public class TerrainParticle extends Particle {
     }
 
     @Override
-	public int getParticleTexture() {
-        return 1;
+    public int getParticleTexture() {
+        return ParticleEngine.TERRAIN_TEXTURE;
     }
 
     @Override
-    public void render(Tessellator t, float partialTick, float xa, float ya, float za, float xa2, float za2) {
+    public void render(Tessellator t, float partialTick, double xOff, double yOff, double zOff, float xa, float ya, float za, float xa2, float za2) {
         if (this.tex == null) return;
         float u0 = (float) this.tex.getSubIconU(this.uo / 4F);
         float u2 = (float) this.tex.getSubIconU(0.25f + this.uo / 4F);
         float v0 = (float) this.tex.getSubIconV(this.uo / 4F);
         float v2 = (float) this.tex.getSubIconV(0.25f + this.uo / 4F);
         float r = 0.1F * this.size;
-        float x = (float)(this.xo + (this.x - this.xo) * partialTick - TerrainParticle.xOff);
-        float y = (float)(this.yo + (this.y - this.yo) * partialTick - TerrainParticle.yOff);
-        float z = (float)(this.zo + (this.z - this.zo) * partialTick - TerrainParticle.zOff);
+        float x = (float) (this.xo + (this.x - this.xo) * partialTick - xOff);
+        float y = (float) (this.yo + (this.y - this.yo) * partialTick - yOff);
+        float z = (float) (this.zo + (this.z - this.zo) * partialTick - zOff);
         float br = 1.0f;
         if (LightmapHelper.isLightmapEnabled()) {
-        	t.setLightmapCoord(getLightmapCoord(partialTick));
+            t.setLightmapCoord(getLightmapCoord(partialTick));
         } else {
-        	br = getBrightness(partialTick);
+            br = getBrightness(partialTick);
         }
         t.setColorOpaque_F(br * this.rCol, br * this.gCol, br * this.bCol);
         t.addVertexWithUV(x - xa * r - xa2 * r, y - ya * r, z - za * r - za2 * r, u0, v2);
diff --git a/src/main/java/net/minecraft/client/entity/particle/WaterDropParticle.java b/src/main/java/net/minecraft/client/entity/particle/WaterDropParticle.java
index 7f7c7640f..8de343b4b 100644
--- a/src/main/java/net/minecraft/client/entity/particle/WaterDropParticle.java
+++ b/src/main/java/net/minecraft/client/entity/particle/WaterDropParticle.java
@@ -18,11 +18,11 @@ public class WaterDropParticle extends Particle {
         this.tex = TextureRegistry.getTexture("minecraft:particle/splash_rain_" + this.random.nextInt(4));
         this.setSize(0.01F, 0.01F);
         this.gravity = 0.06F;
-        this.lifetime = (int)(8D / (Math.random() * 0.8D + 0.2D));
+        this.lifetime = (int) (8D / (Math.random() * 0.8D + 0.2D));
     }
 
     @Override
-	public void tick() {
+    public void tick() {
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
@@ -34,8 +34,7 @@ public class WaterDropParticle extends Particle {
         if (this.lifetime-- <= 0) {
             this.remove();
         }
-        if (this.onGround)
-        {
+        if (this.onGround) {
             if (Math.random() < 0.5D) {
                 this.remove();
             }
@@ -43,10 +42,9 @@ public class WaterDropParticle extends Particle {
             this.zd *= 0.7D;
         }
         Material m = this.world.getBlockMaterial(MathHelper.floor(this.x), MathHelper.floor(this.y), MathHelper.floor(this.z));
-        if(m.isLiquid() || m.isSolid()) {
+        if (m.isLiquid() || m.isSolid()) {
             double y0 = (MathHelper.floor(this.y) + 1) - FluidBlock.getWaterVolume(this.world.getBlockMetadata(MathHelper.floor(this.x), MathHelper.floor(this.y), MathHelper.floor(this.z)));
-            if(this.y < y0)
-            {
+            if (this.y < y0) {
                 remove();
             }
         }
diff --git a/src/main/java/net/minecraft/client/entity/player/LocalPlayer.java b/src/main/java/net/minecraft/client/entity/player/LocalPlayer.java
index 6f7cb3f0c..1ab8f1887 100644
--- a/src/main/java/net/minecraft/client/entity/player/LocalPlayer.java
+++ b/src/main/java/net/minecraft/client/entity/player/LocalPlayer.java
@@ -1,20 +1,22 @@
 package net.minecraft.client.entity.player;
 
+import com.mojang.logging.LogUtils;
 import com.mojang.nbt.CompoundTag;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.entity.particle.TakeAnimationParticle;
-import net.minecraft.client.gui.GuiChest;
-import net.minecraft.client.gui.GuiCrafting;
-import net.minecraft.client.gui.GuiDispenser;
-import net.minecraft.client.gui.GuiEditFlag;
-import net.minecraft.client.gui.GuiEditLabel;
-import net.minecraft.client.gui.GuiEditSign;
-import net.minecraft.client.gui.GuiFurnace;
-import net.minecraft.client.gui.GuiPaintingPicker;
-import net.minecraft.client.gui.GuiPickMonster;
-import net.minecraft.client.gui.GuiTrommel;
-import net.minecraft.client.gui.GuiWandPickerMonster;
+import net.minecraft.client.gui.container.ContainerScreen;
+import net.minecraft.client.gui.container.CraftingScreen;
+import net.minecraft.client.gui.container.DispenserScreen;
+import net.minecraft.client.gui.container.FlagEditorScreen;
+import net.minecraft.client.gui.LabelEditorScreen;
+import net.minecraft.client.gui.SignEditorScreen;
+import net.minecraft.client.gui.container.FurnaceScreen;
+import net.minecraft.client.gui.PaintingPickerScreen;
+import net.minecraft.client.gui.MobPickerScreen;
+import net.minecraft.client.gui.container.TrommelScreen;
+import net.minecraft.client.gui.WandMobPickerScreen;
+import net.minecraft.client.gui.guidebook.GuidebookScreen;
 import net.minecraft.client.input.PlayerInput;
 import net.minecraft.core.achievement.Achievement;
 import net.minecraft.core.achievement.Achievements;
@@ -48,18 +50,11 @@ import net.minecraft.core.util.helper.GetSkinUrlThread;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
-
-// Referenced classes of package net.minecraft.src:
-//            Player, MouseFilter, Session, MovementInput,
-//            Achievements, StatFileWriter, GuiHudToasts, World,
-//            SoundEngine, AxisAlignedBB, NBTTagCompound, GuiEditSign,
-//            GuiChest, GuiCrafting, GuiFurnace, GuiDispenser, 
-//            EntityPickupFX, EffectRenderer, InventoryPlayer, GuiIngame, 
-//            StatBase, Achievement, MathHelper, SignBlockEntity,
-//            IInventory, FurnaceBlockEntity, DispenserBlockEntity, Entity
+import org.slf4j.Logger;
 
 public class LocalPlayer extends Player
 {
+    private static final Logger LOGGER = LogUtils.getLogger();
     public PlayerInput input;
     protected Minecraft mc;
     public final ClientPlayerCommandSender sender;
@@ -72,9 +67,10 @@ public class LocalPlayer extends Player
         sender = new ClientPlayerCommandSender(minecraft, this);
         this.dimension = dimension;
         username = session.username;
+        uuid = session.uuid;
         
         new GetSkinUrlThread(this);
-        System.out.println("logged in with session name: " + username);
+        LOGGER.info("logged in with session name: {}", username);
     }
 
     public float getFovModifier() {
@@ -131,17 +127,17 @@ public class LocalPlayer extends Player
         AchievementToast invToast = new AchievementToast(Achievements.OPEN_INVENTORY, true);
         AchievementToast guideToast = new AchievementToast(Achievements.OPEN_GUIDEBOOK, true);
 
-        if (!this.mc.statsCounter.isUnlocked(Achievements.OPEN_INVENTORY) && !this.mc.guiAchievementToast.isDisplayingToast(invToast))
+        if (!this.mc.statsCounter.isUnlocked(Achievements.OPEN_INVENTORY) && !this.mc.guiToasts.isDisplayingToast(invToast))
         {
-            this.mc.guiAchievementToast.addToast(invToast);
+            this.mc.guiToasts.addToast(invToast);
         }
         if (/*this.mc.statsCounter.isUnlocked(Achievements.OPEN_INVENTORY) &&*/
                 !this.mc.statsCounter.isUnlocked(Achievements.OPEN_GUIDEBOOK) &&
 //                !this.mc.guiAchievementToast.isDisplayingToast(invToast) &&
-                !this.mc.guiAchievementToast.isDisplayingToast(guideToast)
+                !this.mc.guiToasts.isDisplayingToast(guideToast)
         )
         {
-            this.mc.guiAchievementToast.addToast(guideToast);
+            this.mc.guiToasts.addToast(guideToast);
         }
 
         prevTimeInPortal = timeInPortal;
@@ -153,7 +149,7 @@ public class LocalPlayer extends Player
             }
             if(mc.currentScreen != null)
             {
-                mc.displayGuiScreen(null);
+                mc.displayScreen(null);
             }
             if(timeInPortal == 0.0F)
             {
@@ -237,7 +233,7 @@ public class LocalPlayer extends Player
     @Override
     public void wakeUpPlayer(boolean flag, boolean flag1) {
         super.wakeUpPlayer(flag, flag1);
-        mc.displayGuiScreen(null);
+        mc.displayScreen(null);
     }
     
     @Override
@@ -258,85 +254,84 @@ public class LocalPlayer extends Player
     public void closeScreen()
     {
         super.closeScreen();
-        mc.displayGuiScreen(null);
+        mc.displayScreen(null);
     }
 
     @Override
-    public void displayGUIEditSign(SignBlockEntity tileentitysign)
+    public void displaySignEditorScreen(SignBlockEntity blockEntity)
     {
-        mc.displayGuiScreen(new GuiEditSign(tileentitysign));
+        mc.displayScreen(new SignEditorScreen(blockEntity));
     }
 
     @Override
-    public void displayGUIEditFlag(FlagBlockEntity tileEntityFlag)
+    public void displayFlagEditorScreen(FlagBlockEntity blockEntity)
     {
-        mc.displayGuiScreen(new GuiEditFlag(this, tileEntityFlag));
+        mc.displayScreen(new FlagEditorScreen(this, blockEntity));
     }
 
     @Override
-    public void displayGUIChest(Container iinventory)
+    public void displayContainerScreen(Container container)
     {
-        mc.displayGuiScreen(new GuiChest(inventory, iinventory));
+        mc.displayScreen(new ContainerScreen(inventory, container));
     }
 
     @Override
-    public void displayGUIWorkbench(int i, int j, int k)
+    public void displayWorkbenchScreen(int x, int y, int z)
     {
-        mc.displayGuiScreen(new GuiCrafting(inventory, world, i, j, k));
+        mc.displayScreen(new CraftingScreen(inventory, world, x, y, z));
     }
 
     @Override
-    public void displayGUIEditLabel(ItemStack itemstack, int slot)
+    public void displayLabelEditorScreen(ItemStack itemStack, int slot)
     {
-        mc.displayGuiScreen(new GuiEditLabel(itemstack, slot));
+        mc.displayScreen(new LabelEditorScreen(itemStack, slot));
     }
 
     @Override
-    public void displayGUIPaintingPicker()
+    public void displayPaintingPickerScreen()
     {
-        mc.displayGuiScreen(new GuiPaintingPicker(this));
+        mc.displayScreen(new PaintingPickerScreen(this));
     }
 
     @Override
-    public void displayGUIMobSpawnerPicker(int x, int y, int z) {
+    public void displayMobPickerScreen(int x, int y, int z) {
         String currentMobId = ((MobSpawnerBlockEntity) world.getBlockEntity(x, y, z)).getMobId();
-        mc.displayGuiScreen(new GuiPickMonster(currentMobId, x, y, z));
+        mc.displayScreen(new MobPickerScreen(currentMobId, x, y, z));
     }
     @Override
-    public void displayGUIWandMonsterPicker(ItemStack stack) {
-        String currentMobId = stack.getData().getStringOrDefault("monster", "Pig");
-        mc.displayGuiScreen(new GuiWandPickerMonster(currentMobId, stack));
+    public void displayWandMobPickerScreen(ItemStack itemStack) {
+        String currentMobId = itemStack.getData().getStringOrDefault("monster", "Pig");
+        mc.displayScreen(new WandMobPickerScreen(currentMobId, itemStack));
     }
 
     @Override
-    public void displayGUIFurnace(FurnaceBlockEntity tileentityfurnace)
+    public void displayFurnaceScreen(FurnaceBlockEntity blockEntity)
     {
-        mc.displayGuiScreen(new GuiFurnace(inventory, tileentityfurnace));
+        mc.displayScreen(new FurnaceScreen(inventory, blockEntity));
     }
 
     @Override
-    public void displayGUITrommel(TrommelBlockEntity tileEntityTrommel)
+    public void displayTrommelScreen(TrommelBlockEntity blockEntity)
     {
-        mc.displayGuiScreen(new GuiTrommel(inventory, tileEntityTrommel));
+        mc.displayScreen(new TrommelScreen(inventory, blockEntity));
     }
 
     @Override
-    public void displayGUIDispenser(DispenserBlockEntity tileentitydispenser)
+    public void displayDispenserScreen(DispenserBlockEntity blockEntity)
     {
-        mc.displayGuiScreen(new GuiDispenser(inventory, tileentitydispenser));
+        mc.displayScreen(new DispenserScreen(inventory, blockEntity));
     }
 
-    public void displayGUIGuidebook()
-    {
-//        mc.displayGuiScreen(new GuiGuidebook(this));
-        mc.displayGuiScreen(new net.minecraft.client.gui.guidebook.GuiGuidebook());
+    @Override
+    public void displayGuidebookScreen() {
+        mc.displayScreen(new GuidebookScreen());
     }
 
     @Override
     public void onItemPickup(Entity entity, ItemStack item)
     {
         addStat(item.getItem().getStat(StatList.STAT_PICKED_UP), 1);
-        mc.effectRenderer.addEffect(new TakeAnimationParticle(mc.theWorld, entity, this, -0.5F));
+        mc.particleEngine.add(new TakeAnimationParticle(mc.theWorld, entity, this, -0.5F));
     }
 
     public int getPlayerProtectionAmount()
@@ -373,11 +368,12 @@ public class LocalPlayer extends Player
                 }
                 sender.sendMessage(TextFormatting.RED + "Command '" + args[0] + "' does not exist!");
             }catch (Exception e) {
-                e.printStackTrace();
-                mc.ingameGUI.addChatMessage(TextFormatting.RED + "Error!");
+                LOGGER.error("Exception while trying to perform command '" + s + "'!", e);
+                mc.ingameHud.addChatMessage(TextFormatting.RED + "Error!");
+                mc.ingameHud.addChatMessage(TextFormatting.RED + e.getMessage());
             }
         } else {
-            mc.ingameGUI.addChatMessage("<" + getDisplayName() + TextFormatting.RESET + "> " + TextFormatting.WHITE + s);
+            mc.ingameHud.addChatMessage("<" + getDisplayName() + TextFormatting.RESET + "> " + TextFormatting.WHITE + s);
         }
     }
     
@@ -429,7 +425,7 @@ public class LocalPlayer extends Player
     }
 
     @Override
-    public void func_6420_o()
+    public void animate4()
     {
     }
     
@@ -445,7 +441,7 @@ public class LocalPlayer extends Player
             {
                 if(!mc.statsCounter.isUnlocked(achievement))
                 {
-                    mc.guiAchievementToast.addToast(new AchievementToast(achievement, false));
+                    mc.guiToasts.addToast(new AchievementToast(achievement, false));
                 }
                 mc.statsCounter.add(stat, i);
             }
@@ -456,9 +452,9 @@ public class LocalPlayer extends Player
     }
     
     @Override
-    public int getStat(Stat statbase)
+    public int getStat(Stat stat)
     {
-        return mc.statsCounter.readStat(statbase);
+        return mc.statsCounter.readStat(stat);
     }
 
     private boolean isBlockTranslucent(int i, int j, int k)
@@ -530,12 +526,12 @@ public class LocalPlayer extends Player
     
 	@Override
 	public void sendMessage(String message) {
-		mc.ingameGUI.addChatMessage(message);
+		mc.ingameHud.addChatMessage(message);
 	}
 
 	@Override
 	public void sendStatusMessage(String message) {
-		mc.ingameGUI.guiHeldItemTooltip.setString(message);
+		mc.ingameHud.heldItemTooltipElement.setString(message);
 	}
 
 }
